<?php
	# Mantis - a php based bugtracking system
	# Copyright (C) 2000 - 2002  Kenzaburo Ito - kenito@300baud.org
	# Copyright (C) 2002 - 2004  Mantis Team   - mantisbt-dev@lists.sourceforge.net
	# This program is distributed under the terms and conditions of the GPL
	# See the README and LICENSE files for details

	# This file swaps the sequence of two filters on a user's My View and
	# redirects them back to their "My View" account page


	require_once( 'core.php' );

	$t_core_path = config_get( 'core_path' );
	require_once( $t_core_path.'current_user_api.php' );
	require_once( $t_core_path.'filter_api.php' );

	auth_ensure_user_authenticated();

	current_user_ensure_unprotected();

	access_ensure_global_level( config_get('custom_my_view_threshold' ) );


	$f_filter_id	= gpc_get_int( 'filter_id' );
	$f_user_id		= auth_get_current_user_id();

	# TRUE means up, FALSE means down
	$f_move			= gpc_get_bool( 'move' );

	$filters = filter_db_get_my_view( $f_user_id );

	# Only proceed if it is in the list of my view filters
	if (array_key_exists($f_filter_id, $filters)) {

		$filter_keys = array_keys( $filters );

		$currentPos = array_search( $f_filter_id, $filter_keys );

		# make sure this filter can actually be moved in the direction they want
		if ( !( $f_move && $currentPos == 0 ) && !( !$f_move && $currentPos + 1 == count($filters) ) ) {

			# figure out which we are swapping with
			if ($f_move)
				$swapWith = $filter_keys[ $currentPos - 1 ];
			else
				$swapWith = $filter_keys[ $currentPos + 1 ];

			/*
			echo "Moving Filter: ". $f_filter_id ."\n"
				. ($swapWith?"UP":"DOWN") ."\n"
				."Original Position: ". $filters[$f_filter_id]['sequence'] ."\n"
				."New Position: ". $filters[$swapWith]['sequence'] ."\n"
				."Swapping With: ". $swapWith ."\n";
			*/

			filter_set_filter_sequence( $filters[$swapWith]['sequence'],	$f_filter_id,	$f_user_id );
			filter_set_filter_sequence( $filters[$f_filter_id]['sequence'],	$swapWith,		$f_user_id );

			$filters = filter_db_get_my_view( $f_user_id );
		}

	}

	print_header_redirect( 'account_my_view_page.php' );
?>